import math
import copy

class Bruchrechner:
    def __init__(self):
        self.prfacs={}
    def ggt(self,zahl1,zahl2):
        #print zahl1,zahl2
        if (zahl2==0):
            return zahl1
        rest=zahl1%zahl2
        return self.ggt(zahl2,rest)
    def kuerzen(self,bruch):
        #print "Kuerzen"
        #print bruch
        zaehler=bruch[0]
        nenner=bruch[1]
        ggt=self.ggt(zaehler,nenner)
        #print ggt
        return [zaehler/ggt,nenner/ggt]
    def add(self,bruch1,bruch2):
        return self.kuerzen([bruch1[0]*bruch2[1]+bruch2[0]*bruch1[1],bruch1[1]*bruch2[1]]) 
    def sub(self,bruch1,bruch2):
        return  self.kuerzen([bruch1[0]*bruch2[1]-bruch2[0]*bruch1[1],bruch1[1]*bruch2[1]])
    def mult(self,bruch1,bruch2):
        #print bruch1,bruch2
        return self.kuerzen([bruch1[0]*bruch2[0],bruch1[1]*bruch2[1]])
    def div(self,bruch1,bruch2):
        #print bruch1,bruch2
        return self.kuerzen([bruch1[0]*bruch2[1],bruch1[1]*bruch2[0]])
    def get_stored_data(self):
        return {"primfaktoren":self.prfacs}


